'########################################################
'### TERMOMETR DO CIGNIKA BEZ WYGASZANIA WYWIETLACZA ##
'########################################################

$regfile = "2313def.dat"
$crystal = 1000000

Config Portd = Output                             'definiowanie wej/wyj
Config Portb = &B11111111
        Portb = &B01000011

Config 1wire = Pinb.6
Config Watchdog = 256

Config Timer0 = Timer , Prescale = 8 , On Timer0 Wysw       'ustawianie timerw
Enable Interrupts
Enable Timer0
Load Timer0 = 0

Dim Licz As Byte , Odliczaj As Word , Wyg_wys As Byte , Pomoc As Byte       'deklaracja zmiennych
Dim W As Byte , T1 As Long , L As Byte , Kod As Byte , Nr As Byte
Dim A As Byte , B As Byte

Reset W                                           'zmienne potrzebne do pomiaru i wywietlania temp.
Pomoc = 1
A = 0
B = 0
Dim Odczyt(2) As Byte
Nr = 0
L = 0

Start Watchdog
Reset Watchdog


Do
   Disable Timer0
   1wreset
   1wwrite &HCC
   1wwrite &H44
   Enable Timer0
Wait 1
   Disable Timer0
   1wreset
   1wwrite &HCC
   1wwrite &HBE

Odczyt(1) = 1wread(2)                             'odczytywanie i przeliczanie na st. C
T1 = Odczyt(2)
Shift T1 , Left , 8
T1 = T1 + Odczyt(1)
T1 = T1 / 16
Enable Timer0
If T1 <> 85 Then
   L = T1
   L = Makebcd(l)
   B = L And &B00001111
   Shift L , Right , 4
   A = L
Else
   W = 0
End If


'**********************************************
'*** Sterowanie diodami i brzczykiem piezo ***
'**********************************************

' Stan wysoki na porcie PB.5 do 70 stopni
If T1 <= 70 Then
   Set Portb.5
Else
      Reset Portb.5
End If

' Stan wysoki na porcie PB.4 od 50 do 90 stopni
If T1 >= 50 And T1 <= 90 Then
   Set Portb.4
Else
      Reset Portb.4
End If

' Stan wysoki na porcie PB.3 od 80 stopni
If T1 >= 80 Then
   Set Portb.3
Else
      Reset Portb.3
End If

' Stan wysoki na porcie PB.7 od 95 stopni
If T1 >= 95 Then
   Set Portb.7
Else
   If T1 < 93 Then
      Reset Portb.7
End If
   End If

Loop
End


'****************************
'*** Obsuga wywietlaczy ***
'****************************

Wysw:
Reset Watchdog
Load Timer0 = 0
Portb.0 = 0
Reset Portb.1
If A = 0 And B = 0 Then
   Portb.0 = 1
   Portb.1 = 1
   Portd = &B00111111
   W = 0
Else
If Nr = 0 Then
   If A > 0 Then
      Portd = Lookup(a , Kody)
      Portb.0 = 1
   End If
    Nr = 1
Elseif Nr = 1 Then
   Portd = Lookup(b , Kody)
   Portb.1 = 1
   Nr = 0
End If
   End If
Return


' Kody cyfr
Kody:
Data &B01000000 , &B01111001 , &B000100100 , &B00110000 , &B00011001,
Data &B00010010 , &B00000010 , &B01111000 , &B00000000 , &B00010000